

#include <Arduino.h>
#include <SPI.h>
#if not defined (_VARIANT_ARDUINO_DUE_X_)
#include <SoftwareSerial.h>
#endif

#include "Adafruit_BLE.h"
#include "Adafruit_BluefruitLE_SPI.h"
#include "Adafruit_BluefruitLE_UART.h"

#include "BluefruitConfig.h"

#define FACTORYRESET_ENABLE         0
#define MINIMUM_FIRMWARE_VERSION    "0.6.6"
/*=========================================================================*/
const int buttonPin = 5;
const int buttonPin2 = 3;
const int buttonPin3 = 2;

/////////////////
int current;         // Current state of the button
// (LOW is pressed b/c i'm using the pullup resistors)
long millis_held;    // How long the button was held (milliseconds)
long secs_held;      // How long the button was held (seconds)
long prev_secs_held; // How long the button was held in the previous check
byte previous = HIGH;
unsigned long firstTime; // how long since the button was first pressed

int current2;         // Current state of the button
// (LOW is pressed b/c i'm using the pullup resistors)
long millis_held2;    // How long the button was held (milliseconds)
long secs_held2;      // How long the button was held (seconds)
long prev_secs_held2; // How long the button was held in the previous check
byte previous2 = HIGH;
unsigned long firstTime2; // how long since the button was first pressed

int current3;         // Current state of the button
// (LOW is pressed b/c i'm using the pullup resistors)
long millis_held3;    // How long the button was held (milliseconds)
long secs_held3;      // How long the button was held (seconds)
long prev_secs_held3; // How long the button was held in the previous check
byte previous3 = HIGH;
unsigned long firstTime3; // how long since the button was first pressed
////////////////////

Adafruit_BluefruitLE_SPI ble(BLUEFRUIT_SPI_CS, BLUEFRUIT_SPI_IRQ, BLUEFRUIT_SPI_RST);

// A small helper
void error(const __FlashStringHelper*err) {
  Serial.println(err);
  while (1);
}


void setup(void)
{
  pinMode(buttonPin, INPUT_PULLUP);
  pinMode(buttonPin2, INPUT_PULLUP);
  pinMode(buttonPin3, INPUT_PULLUP);

  delay(500);

  Serial.begin(115200);
  Serial.println(F("Adafruit Bluefruit HID Keyboard Example"));
  Serial.println(F("---------------------------------------"));

  /* Initialise the module */
  Serial.print(F("Initialising the Bluefruit LE module: "));

  if ( !ble.begin(VERBOSE_MODE) )
  {
    error(F("Couldn't find Bluefruit, make sure it's in CoMmanD mode & check wiring?"));
  }
  Serial.println( F("OK!") );

  if ( FACTORYRESET_ENABLE )
  {
    /* Perform a factory reset to make sure everything is in a known state */
    Serial.println(F("Performing a factory reset: "));
    if ( ! ble.factoryReset() ) {
      error(F("Couldn't factory reset"));
    }
  }

  /* Disable command echo from Bluefruit */
  ble.echo(false);

  Serial.println("Requesting Bluefruit info:");
  /* Print Bluefruit information */
  ble.info();

  /* Change the device name to make it easier to find */
  Serial.println(F("Setting device name to 'Bluefruit Keyboard': "));
  if (! ble.sendCommandCheckOK(F( "AT+GAPDEVNAME=Bluefruit Keyboard" )) ) {
    error(F("Could not set device name?"));
  }

  /* Enable HID Service */
  Serial.println(F("Enable HID Service (including Keyboard): "));
  if ( ble.isVersionAtLeast(MINIMUM_FIRMWARE_VERSION) )
  {
    if ( !ble.sendCommandCheckOK(F( "AT+BleHIDEn=On" ))) {
      error(F("Could not enable Keyboard"));
    }
  } else
  {
    if (! ble.sendCommandCheckOK(F( "AT+BleKeyboardEn=On"  ))) {
      error(F("Could not enable Keyboard"));
    }
  }

  /* Add or remove service requires a reset */
  Serial.println(F("Performing a SW reset (service changes require a reset): "));
  if (! ble.reset() ) {
    error(F("Couldn't reset??"));
  }

  Serial.println();
  Serial.println(F("Go to your phone's Bluetooth settings to pair your device"));
  Serial.println(F("then open an application that accepts keyboard input"));

  Serial.println();
  Serial.println(F("Enter the character(s) to send:"));
  Serial.println(F("- \\r for Enter"));
  Serial.println(F("- \\n for newline"));
  Serial.println(F("- \\t for tab"));
  Serial.println(F("- \\b for backspace"));

  Serial.println();
}


void loop()
{
  current = digitalRead(buttonPin);
  current2 = digitalRead(buttonPin2);
  current3 = digitalRead(buttonPin3);

  /////////////////// switch 1

  // if the button state changes to pressed, remember the start time
  if (current == LOW && previous == HIGH && (millis() - firstTime) > 200) {
    firstTime = millis();
  }

  millis_held = (millis() - firstTime);

  if (millis_held  <= 100) {
    Serial.println("sound");
    ble.print("AT+BleKeyboard=");
    delay(5);
    ble.println('n');
    delay(300);
  }

  previous = current;
  prev_secs_held = secs_held;

  /////////////////// switch 2

  // if the button state changes to pressed, remember the start time
  if (current2 == LOW && previous2 == HIGH && (millis() - firstTime2) > 200) {
    firstTime2 = millis();
  }

  millis_held2 = (millis() - firstTime2);

  if (millis_held2  <= 100) {
    Serial.println("sound");
    ble.print("AT+BleKeyboard=");
    delay(5);
    ble.println('b');
    delay(300);
  }

  previous2 = current2;
  prev_secs_held2 = secs_held2;

  /////////////////// switch 3

  // if the button state changes to pressed, remember the start time
  if (current3 == LOW && previous3 == HIGH && (millis() - firstTime3) > 200) {
    firstTime3 = millis();
  }

  millis_held3 = (millis() - firstTime3);

  if (millis_held3  <= 100) {
    Serial.println("sound");
    ble.print("AT+BleKeyboard=");
    delay(5);
    ble.println('v');
    delay(300);
  }

  previous3 = current3;
  prev_secs_held3 = secs_held3;


}

